module CabezaDeTermo
	module Assets
		# Base class for classes that models a reference to an asset or bundle.
		# These references are held by a Bundle object when defined in the Library:definition block.
		#
		class ReferenceBase
			# Answer a new instance on the reference_id.
			def self.on(reference_id)
				new(reference_id)
			end

			# Initialize the instance on the reference_id.
			def initialize(reference_id)
				@reference_id = reference_id
			end

			# Answer the reference_id
			def reference_id
				@reference_id
			end

			# Add the referenced assets to the assets_collector
			def collect_assets_with(assets_collector)
				CdT.subclass_responsibility
			end
		end
	end
end