module CabezaDeTermo
	module Assets
		# This object collects the assets from both an included asset and the assets included
		# by a required bundle.
		#
		class Collector
			# Initialize the instance
			def initialize
				@assets = []
			end

			# Answer the collected assets. The answer is a collection of strings.
			def assets
				@assets
			end

			# Add the asset to the collected assets.
			# Ignore the asset if it was already included.
			def include(asset)
				return if @assets.include?(asset)
				@assets << asset
			end

			# Add the assets included in the bundle named bundle_name.
			def require(bundle_name)
				bundle_named(bundle_name)
					.collect_assets_with(self)
			end

			# Answer the bundle named bundle_name.
			def bundle_named(bundle_name)
				Library.bundle_named bundle_name
			end
		end
	end
end