require 'cabeza-de-termo/assets/collectors/collector'

module CabezaDeTermo
	module Assets
		# Collects assets from a rendering scope.
		class RenderingScopeAssetsCollector
			# Initialize the instance
			def initialize
				@assets_collector = new_assets_collector
			end

			# Answer the collection of assets collected into the Collector.
			def collected_assets
				@assets_collector.assets
			end

			# Collect the stylesheets from the layout and view on the rendering_scope.
			def collect_stylesheets_from(rendering_scope)
				rendering_scope.collect_stylesheets_with assets_collector
				collected_assets
			end

			# Collect the javascripts from the layout and view on the rendering_scope.
			def collect_javascripts_from(rendering_scope)
				rendering_scope.collect_javascripts_with assets_collector
				collected_assets
			end

			protected
			# Answer a new Collector object to perform the assets recollection.
			def new_assets_collector
				Collector.new
			end

			# Answer the Collector instance.
			def assets_collector
				@assets_collector
			end
		end
	end
end